searchData={"items":[{"type":"module","title":"ExOciSdk","doc":"Documentation for `ExOciSdk`.","ref":"ExOciSdk.html"},{"type":"module","title":"ExOciSdk.Client","doc":"Main client for interacting with the OCI API.\nManages configurations, HTTP client, and JSON serialization.","ref":"ExOciSdk.Client.html"},{"type":"type","title":"ExOciSdk.Client.client_option/0","doc":"","ref":"ExOciSdk.Client.html#t:client_option/0"},{"type":"function","title":"ExOciSdk.Client.create!/2","doc":"Creates a new instance of the OCI client.","ref":"ExOciSdk.Client.html#create!/2"},{"type":"function","title":"Parameters - ExOciSdk.Client.create!/2","doc":"* `config` - Required configuration for the client\n  * `opts` - Optional parameters to customize the client\n    * `:http_client` - Tuple with {module, options} for the HTTP client. Module must implements `ExOciSdk.HTTPClient`\n    * `:json` - Tuple with {module, options} for JSON serialization. Module must implements `ExOciSdk.JSON`","ref":"ExOciSdk.Client.html#create!/2-parameters"},{"type":"function","title":"Returns - ExOciSdk.Client.create!/2","doc":"* `t:t/0` - The configuration struct","ref":"ExOciSdk.Client.html#create!/2-returns"},{"type":"function","title":"Raises - ExOciSdk.Client.create!/2","doc":"* `ArgumentError` if any of the provided options are invalid","ref":"ExOciSdk.Client.html#create!/2-raises"},{"type":"type","title":"ExOciSdk.Client.create_opts/0","doc":"","ref":"ExOciSdk.Client.html#t:create_opts/0"},{"type":"type","title":"ExOciSdk.Client.t/0","doc":"","ref":"ExOciSdk.Client.html#t:t/0"},{"type":"module","title":"ExOciSdk.Config","doc":"Provides configuration structure and validation for Oracle Cloud Infrastructure (OCI) credentials.\n\nThis module manages the configuration required for authenticating with OCI services,\nincluding user, tenancy information, and private key authentication.","ref":"ExOciSdk.Config.html"},{"type":"type","title":"ExOciSdk.Config.config_options/0","doc":"Options for creating a new configuration.","ref":"ExOciSdk.Config.html#t:config_options/0"},{"type":"type","title":"Fields - ExOciSdk.Config.config_options/0","doc":"* `user` - The OCID of the user making the request\n  * `fingerprint` - Fingerprint of the public key uploaded to OCI\n  * `tenancy` - The OCID of your tenancy\n  * `region` - The region of the OCI services being accessed\n  * `key_content` - The private key content as a string (mutually exclusive with `key_content_file`)\n  * `key_content_file` - Path to the private key file (mutually exclusive with `key_content`)","ref":"ExOciSdk.Config.html#t:config_options/0-fields"},{"type":"function","title":"ExOciSdk.Config.from_file!/2","doc":"Creates a new configuration from an OCI config file.\n\nThe function reads and parses an INI-formatted OCI configuration file and creates\na new configuration struct based on the specified profile.","ref":"ExOciSdk.Config.html#from_file!/2"},{"type":"function","title":"Parameters - ExOciSdk.Config.from_file!/2","doc":"* `config_file_path` - Path to the OCI config file. Defaults to \"~/.oci/config\"\n  * `profile` - The profile name to use from the config file. Defaults to \"DEFAULT\"","ref":"ExOciSdk.Config.html#from_file!/2-parameters"},{"type":"function","title":"Returns - ExOciSdk.Config.from_file!/2","doc":"* `t:t/0` - The configuration struct","ref":"ExOciSdk.Config.html#from_file!/2-returns"},{"type":"function","title":"Raises - ExOciSdk.Config.from_file!/2","doc":"* `ArgumentError` - If the config file cannot be parsed or if the specified profile is not found\n  * All raises from new!/1","ref":"ExOciSdk.Config.html#from_file!/2-raises"},{"type":"function","title":"ExOciSdk.Config.new!/1","doc":"Creates a new configuration struct with the provided options.\n\nThis function accepts either direct key content or a path to a key file, but not both.\nThe private key content will be validated to ensure it's in the correct PEM format.","ref":"ExOciSdk.Config.html#new!/1"},{"type":"function","title":"Parameters - ExOciSdk.Config.new!/1","doc":"* `options` - Map containing configuration values. See `t:config_options/0` for details.","ref":"ExOciSdk.Config.html#new!/1-parameters"},{"type":"function","title":"Returns - ExOciSdk.Config.new!/1","doc":"* `t:t/0` - The configuration struct","ref":"ExOciSdk.Config.html#new!/1-returns"},{"type":"function","title":"Raises - ExOciSdk.Config.new!/1","doc":"* `ArgumentError` - If the key content is invalid or not in PEM format\n  * `File.Error` - If the key file cannot be read (when using `key_content_file`)","ref":"ExOciSdk.Config.html#new!/1-raises"},{"type":"type","title":"ExOciSdk.Config.t/0","doc":"Configuration structure for OCI authentication.","ref":"ExOciSdk.Config.html#t:t/0"},{"type":"type","title":"Fields - ExOciSdk.Config.t/0","doc":"* `user` - The OCID of the user making the request\n  * `fingerprint` - Fingerprint of the public key uploaded to OCI\n  * `tenancy` - The OCID of your tenancy\n  * `region` - The region of the OCI services being accessed\n  * `key_content` - The private key content used for signing requests","ref":"ExOciSdk.Config.html#t:t/0-fields"},{"type":"module","title":"ExOciSdk.Response.Types","doc":"","ref":"ExOciSdk.Response.Types.html"},{"type":"type","title":"ExOciSdk.Response.Types.response_error/0","doc":"","ref":"ExOciSdk.Response.Types.html#t:response_error/0"},{"type":"type","title":"ExOciSdk.Response.Types.response_metadata/0","doc":"","ref":"ExOciSdk.Response.Types.html#t:response_metadata/0"},{"type":"type","title":"ExOciSdk.Response.Types.response_success/0","doc":"","ref":"ExOciSdk.Response.Types.html#t:response_success/0"},{"type":"type","title":"ExOciSdk.Response.Types.return_type/0","doc":"","ref":"ExOciSdk.Response.Types.html#t:return_type/0"},{"type":"behaviour","title":"ExOciSdk.HTTPClient","doc":"Defines the behaviour for HTTP clients in ExOciSdk.\n\nThis module specifies the contract that all HTTP client implementations must follow.\nIt provides type specifications and a callback for making HTTP requests.","ref":"ExOciSdk.HTTPClient.html"},{"type":"type","title":"ExOciSdk.HTTPClient.body/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:body/0"},{"type":"callback","title":"ExOciSdk.HTTPClient.deps/0","doc":"defines the dependencies necessary for the module","ref":"ExOciSdk.HTTPClient.html#c:deps/0"},{"type":"type","title":"ExOciSdk.HTTPClient.error_reason/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:error_reason/0"},{"type":"type","title":"ExOciSdk.HTTPClient.headers/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:headers/0"},{"type":"type","title":"ExOciSdk.HTTPClient.http_method/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:http_method/0"},{"type":"type","title":"ExOciSdk.HTTPClient.options/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:options/0"},{"type":"callback","title":"ExOciSdk.HTTPClient.request/5","doc":"Makes an HTTP request.","ref":"ExOciSdk.HTTPClient.html#c:request/5"},{"type":"callback","title":"Parameters - ExOciSdk.HTTPClient.request/5","doc":"* `method` - HTTP method as atom (e.g., `:get`, `:post`)\n  * `url` - Full URL for the request\n  * `body` - Request body as iodata\n  * `headers` - List of request headers as tuples\n  * `options` - Additional options for the request","ref":"ExOciSdk.HTTPClient.html#c:request/5-parameters"},{"type":"callback","title":"Returns - ExOciSdk.HTTPClient.request/5","doc":"* `{:ok, response}` - Successful response with status, headers and body\n  * `{:error, reason}` - Error occurred during request","ref":"ExOciSdk.HTTPClient.html#c:request/5-returns"},{"type":"type","title":"ExOciSdk.HTTPClient.response/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:response/0"},{"type":"type","title":"ExOciSdk.HTTPClient.url/0","doc":"","ref":"ExOciSdk.HTTPClient.html#t:url/0"},{"type":"module","title":"ExOciSdk.HTTPClient.Hackney","doc":"HTTP client implementation using Hackney.\n\nThis module implements the `ExOciSdk.HTTPClient` behaviour using the Hackney HTTP client.\nIt handles the translation between Hackney's response format and the expected format\ndefined in the behaviour.","ref":"ExOciSdk.HTTPClient.Hackney.html"},{"type":"function","title":"ExOciSdk.HTTPClient.Hackney.deps/0","doc":"Define the Hackney HTTP client as a dependency for this module","ref":"ExOciSdk.HTTPClient.Hackney.html#deps/0"},{"type":"function","title":"ExOciSdk.HTTPClient.Hackney.request/5","doc":"Makes an HTTP request using Hackney.\n\nImplements the `c:ExOciSdk.HTTPClient.request/5` callback using Hackney as the underlying\nHTTP client. Converts Hackney's response format to match the expected behaviour format.","ref":"ExOciSdk.HTTPClient.Hackney.html#request/5"},{"type":"function","title":"Parameters - ExOciSdk.HTTPClient.Hackney.request/5","doc":"* `method` - HTTP method as atom (e.g., `:get`, `:post`)\n  * `url` - Full URL for the request as binary\n  * `body` - Request body as iodata\n  * `headers` - List of request headers as tuples\n  * `options` - Additional options for the request","ref":"ExOciSdk.HTTPClient.Hackney.html#request/5-parameters"},{"type":"behaviour","title":"ExOciSdk.JSON","doc":"Defines the behavior for JSON encoding and decoding.\nThis module provides a consistent interface for working with JSON,\nallowing different implementations (such as Jason, Poison, etc).","ref":"ExOciSdk.JSON.html"},{"type":"callback","title":"ExOciSdk.JSON.decode!/2","doc":"Decodes JSON into an Elixir map.","ref":"ExOciSdk.JSON.html#c:decode!/2"},{"type":"callback","title":"Parameters - ExOciSdk.JSON.decode!/2","doc":"* `input` - JSON string or iodata to decode\n  * `options` - Decoding options","ref":"ExOciSdk.JSON.html#c:decode!/2-parameters"},{"type":"callback","title":"Raises - ExOciSdk.JSON.decode!/2","doc":"* `decode_error` - If the input is not valid JSON","ref":"ExOciSdk.JSON.html#c:decode!/2-raises"},{"type":"type","title":"ExOciSdk.JSON.decode_error/0","doc":"","ref":"ExOciSdk.JSON.html#t:decode_error/0"},{"type":"callback","title":"ExOciSdk.JSON.deps/0","doc":"defines the dependencies necessary for the module","ref":"ExOciSdk.JSON.html#c:deps/0"},{"type":"type","title":"ExOciSdk.JSON.encode_error/0","doc":"","ref":"ExOciSdk.JSON.html#t:encode_error/0"},{"type":"callback","title":"ExOciSdk.JSON.encode_to_iodata!/2","doc":"Encodes a map into JSON as iodata.","ref":"ExOciSdk.JSON.html#c:encode_to_iodata!/2"},{"type":"callback","title":"Parameters - ExOciSdk.JSON.encode_to_iodata!/2","doc":"* `input` - Map to be encoded\n  * `options` - Encoding options","ref":"ExOciSdk.JSON.html#c:encode_to_iodata!/2-parameters"},{"type":"callback","title":"Raises - ExOciSdk.JSON.encode_to_iodata!/2","doc":"* `encode_error` - If the input cannot be encoded to JSON","ref":"ExOciSdk.JSON.html#c:encode_to_iodata!/2-raises"},{"type":"type","title":"ExOciSdk.JSON.json_options/0","doc":"","ref":"ExOciSdk.JSON.html#t:json_options/0"},{"type":"module","title":"ExOciSdk.JSON.Jason","doc":"Implementation of the JSON behavior using the Jason library.","ref":"ExOciSdk.JSON.Jason.html"},{"type":"function","title":"ExOciSdk.JSON.Jason.decode!/2","doc":"Implementation of `c:ExOciSdk.JSON.decode!/2` using Jason.","ref":"ExOciSdk.JSON.Jason.html#decode!/2"},{"type":"function","title":"ExOciSdk.JSON.Jason.deps/0","doc":"Define the Jason json parser/generator as a dependency for this module","ref":"ExOciSdk.JSON.Jason.html#deps/0"},{"type":"function","title":"ExOciSdk.JSON.Jason.encode_to_iodata!/2","doc":"Implementation of `c:ExOciSdk.JSON.encode_to_iodata!/2` using Jason.","ref":"ExOciSdk.JSON.Jason.html#encode_to_iodata!/2"},{"type":"module","title":"ExOciSdk.Queue.QueueClient","doc":"Client for interacting with OCI Queue Service messages and operations.\n\nThis module handles message-level operations for OCI Queues, including:\n\n- Reading messages (`get_messages/3`)\n- Writing messages (`put_messages/4`)\n- Deleting messages (`delete_message/4`, `delete_messages/4`)\n- Updating messages (`update_message/5`, `update_messages/4`)\n- Retrieving queue stats (`get_stats/3`)\n- Listing channels (`list_channels/3`)\n\nFor queue administration operations like creating, deleting, and updating queues,\nsee `ExOciSdk.Queue.QueueAdminClient`.","ref":"ExOciSdk.Queue.QueueClient.html"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.create/2","doc":"Creates a new QueueClient instance.","ref":"ExOciSdk.Queue.QueueClient.html#create/2"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.create/2","doc":"* `client` - Base sdk client, see `t:ExOciSdk.Client.t/0`\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_create_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#create/2-parameters"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.delete_message/4","doc":"Deletes a single message from a queue.","ref":"ExOciSdk.Queue.QueueClient.html#delete_message/4"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.delete_message/4","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `message_receipt` - Receipt of the message to delete\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_default_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#delete_message/4-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.delete_message/4","doc":"* `{:ok, response}` - On success\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#delete_message/4-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.delete_messages/4","doc":"Deletes multiple messages from a queue in a single request.","ref":"ExOciSdk.Queue.QueueClient.html#delete_messages/4"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.delete_messages/4","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `delete_messages_input` - Details of messages to delete, see `t:ExOciSdk.Queue.Types.delete_messages_input/0`\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_default_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#delete_messages/4-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.delete_messages/4","doc":"* `{:ok, response}` - On success\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#delete_messages/4-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.get_messages/3","doc":"Retrieves messages from a queue.","ref":"ExOciSdk.Queue.QueueClient.html#get_messages/3"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.get_messages/3","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.get_messages_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#get_messages/3-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.get_messages/3","doc":"* `{:ok, response}` - On success, where response contains the messages\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#get_messages/3-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.get_stats/3","doc":"Retrieves statistics for a queue.","ref":"ExOciSdk.Queue.QueueClient.html#get_stats/3"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.get_stats/3","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.get_stats_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#get_stats/3-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.get_stats/3","doc":"* `{:ok, response}` - On success, where response contains queue statistics\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#get_stats/3-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.list_channels/3","doc":"Lists channels in a queue.","ref":"ExOciSdk.Queue.QueueClient.html#list_channels/3"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.list_channels/3","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.list_channels_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#list_channels/3-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.list_channels/3","doc":"* `{:ok, response}` - On success, where response contains list of channels\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#list_channels/3-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.put_messages/4","doc":"Puts messages into a queue.","ref":"ExOciSdk.Queue.QueueClient.html#put_messages/4"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.put_messages/4","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `put_messages_input` - Message details, see `t:ExOciSdk.Queue.Types.put_messages_input/0`\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_default_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#put_messages/4-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.put_messages/4","doc":"* `{:ok, response}` - On success\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#put_messages/4-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.service_settings/0","doc":"Returns defaults service configuration settings `t:ExOciSdk.Queue.Types.service_settings/0`.","ref":"ExOciSdk.Queue.QueueClient.html#service_settings/0"},{"type":"type","title":"ExOciSdk.Queue.QueueClient.t/0","doc":"Queue client structure containing the base client and service configuration.\n\n* `:client` - The base OCI client instance, see `t:ExOciSdk.Client.t/0`\n* `:service_endpoint` - Optional custom service endpoint URL","ref":"ExOciSdk.Queue.QueueClient.html#t:t/0"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.update_message/5","doc":"Updates a single message's visibility timeout.","ref":"ExOciSdk.Queue.QueueClient.html#update_message/5"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.update_message/5","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `message_receipt` - Receipt of the message to update\n  * `update_message_input` - Update details, see `t:ExOciSdk.Queue.Types.update_message_input/0`\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_default_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#update_message/5-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.update_message/5","doc":"* `{:ok, response}` - On success\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#update_message/5-returns"},{"type":"function","title":"ExOciSdk.Queue.QueueClient.update_messages/4","doc":"Updates visibility timeout for multiple messages in a single request.","ref":"ExOciSdk.Queue.QueueClient.html#update_messages/4"},{"type":"function","title":"Parameters - ExOciSdk.Queue.QueueClient.update_messages/4","doc":"* `queue_client` - Queue client instance `t:t/0`\n  * `queue_id` - Target queue identifier\n  * `update_messages_input` - Update details, see `t:ExOciSdk.Queue.Types.update_messages_input/0`\n  * `opts` - Options list, see `t:ExOciSdk.Queue.Types.queue_client_default_opts/0`","ref":"ExOciSdk.Queue.QueueClient.html#update_messages/4-parameters"},{"type":"function","title":"Returns - ExOciSdk.Queue.QueueClient.update_messages/4","doc":"* `{:ok, response}` - On success\n  * `{:error, reason}` - On failure","ref":"ExOciSdk.Queue.QueueClient.html#update_messages/4-returns"},{"type":"module","title":"ExOciSdk.Queue.Types","doc":"Defines types used by the Queue Client.","ref":"ExOciSdk.Queue.Types.html"},{"type":"type","title":"ExOciSdk.Queue.Types.channel_filter/0","doc":"Filter string for querying specific channels.","ref":"ExOciSdk.Queue.Types.html#t:channel_filter/0"},{"type":"type","title":"ExOciSdk.Queue.Types.channel_id/0","doc":"Unique identifier for a channel within a queue.","ref":"ExOciSdk.Queue.Types.html#t:channel_id/0"},{"type":"type","title":"ExOciSdk.Queue.Types.delete_messages_input/0","doc":"Structure for deleting multiple messages from a queue.","ref":"ExOciSdk.Queue.Types.html#t:delete_messages_input/0"},{"type":"type","title":"ExOciSdk.Queue.Types.get_messages_opts/0","doc":"Options for retrieving messages from a queue.\n\n* `:opc_request_id` - Custom request identifier\n* `:visibility_in_seconds` - Duration the message remains invisible to other consumers\n* `:timeout_in_seconds` - How long to wait for messages if queue is empty\n* `:limit` - Maximum number of messages to retrieve\n* `:channel_filter` - Filter for specific channels","ref":"ExOciSdk.Queue.Types.html#t:get_messages_opts/0"},{"type":"type","title":"ExOciSdk.Queue.Types.get_stats_opts/0","doc":"Options for retrieving queue statistics.\n\n* `:opc_request_id` - Custom request identifier\n* `:channel_filter` - Filter for specific channels","ref":"ExOciSdk.Queue.Types.html#t:get_stats_opts/0"},{"type":"type","title":"ExOciSdk.Queue.Types.list_channels_opts/0","doc":"Options for listing channels in a queue.\n\n* `:opc_request_id` - Custom request identifier\n* `:limit` - Maximum number of channels to retrieve\n* `:page` - Page number for pagination\n* `:channel_filter` - Filter for specific channels","ref":"ExOciSdk.Queue.Types.html#t:list_channels_opts/0"},{"type":"type","title":"ExOciSdk.Queue.Types.message/0","doc":"Message map containing the actual content and associated metadata.","ref":"ExOciSdk.Queue.Types.html#t:message/0"},{"type":"type","title":"ExOciSdk.Queue.Types.message_metadata/0","doc":"Metadata map associated with a message, including channel information and custom properties.","ref":"ExOciSdk.Queue.Types.html#t:message_metadata/0"},{"type":"type","title":"ExOciSdk.Queue.Types.message_receipt/0","doc":"Receipt identifier for a message. Used in operations that manipulate existing messages.","ref":"ExOciSdk.Queue.Types.html#t:message_receipt/0"},{"type":"type","title":"ExOciSdk.Queue.Types.opc_request_id/0","doc":"Request identifier used for tracing and debugging purposes.","ref":"ExOciSdk.Queue.Types.html#t:opc_request_id/0"},{"type":"type","title":"ExOciSdk.Queue.Types.put_messages_input/0","doc":"Map for putting multiple messages into a queue.","ref":"ExOciSdk.Queue.Types.html#t:put_messages_input/0"},{"type":"type","title":"ExOciSdk.Queue.Types.queue_client_create_opts/0","doc":"Options for creating a new queue client.\n\n* `:service_endpoint` - Custom service endpoint URL","ref":"ExOciSdk.Queue.Types.html#t:queue_client_create_opts/0"},{"type":"type","title":"ExOciSdk.Queue.Types.queue_client_default_opts/0","doc":"Default options available for most queue operations.\n\n* `:opc_request_id` - Custom request identifier for tracing","ref":"ExOciSdk.Queue.Types.html#t:queue_client_default_opts/0"},{"type":"type","title":"ExOciSdk.Queue.Types.queue_id/0","doc":"Unique identifier for a queue.","ref":"ExOciSdk.Queue.Types.html#t:queue_id/0"},{"type":"type","title":"ExOciSdk.Queue.Types.service_settings/0","doc":"Default Queue service settings\n\n* `:service_endpoint` - Default OCI service endpoint\n* `:content_type` - Default content type for requests\n* `:accept` - Default accept header for requests","ref":"ExOciSdk.Queue.Types.html#t:service_settings/0"},{"type":"type","title":"ExOciSdk.Queue.Types.update_message_input/0","doc":"Map for updating a single message's visibility timeout.","ref":"ExOciSdk.Queue.Types.html#t:update_message_input/0"},{"type":"type","title":"ExOciSdk.Queue.Types.update_messages_input/0","doc":"Structure for updating visibility timeout for multiple messages.","ref":"ExOciSdk.Queue.Types.html#t:update_messages_input/0"},{"type":"extras","title":"ex-oci-sdk","doc":"# ex-oci-sdk\n\nAn Elixir SDK for Oracle Cloud Infrastructure (OCI) designed to provide a clean and efficient way to interact with OCI services. Built on Elixir's principles of simplicity and maintainability, this SDK offers a straightforward interface while maintaining the robustness required for enterprise cloud applications.","ref":"readme.html"},{"type":"extras","title":"Installation - ex-oci-sdk","doc":"The package can be installed by adding `ex_oci_sdk` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_oci_sdk, \"~> 0.1.0\"},\n    # Optional dependencies\n    {:hackney, \"~> 1.20.1\"},  # Default HTTP client\n    {:jason, \"~> 1.4.4\"}      # Default JSON parser\n  ]\nend\n```\n\nThe SDK is designed to be flexible with its dependencies. While it comes with default implementations using Hackney for HTTP requests and Jason for JSON parsing, you can implement your own client modules by following the behaviour specifications in the documentation.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ex-oci-sdk","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Basic Example - ex-oci-sdk","doc":"```elixir\n# Loading configs from a OCI config file\nconfig =\n  ExOciSdk.Config.from_file!(\"~/.oci/config\")\n\n# Create SDK Base Client\nclient = ExOciSdk.Client.create!(config)\n\n# Create Queue Client\nqueue_client =\n  ExOciSdk.Queue.QueueClient.create(client)\n\nqueue_id = \"QUEUE_OCID\"\n\n# Put messages in a queue\n{:ok, _} = ExOciSdk.Queue.QueueClient.put_messages(queue_client, queue_id, %{\n  \"messages\" => [\n    %{\"content\" => \"Hello world from ex-oci-sdk\"},\n    %{\"content\" => \":D\"},\n  ]\n})\n\n# Get messages from a queue\n{:ok, messages} = ExOciSdk.Queue.QueueClient.get_messages(queue_client, queue_id,\n   limit: 10,\n   timeout_in_seconds: 0\n)\n```","ref":"readme.html#basic-example"},{"type":"extras","title":"Supported Services - ex-oci-sdk","doc":"- Queue","ref":"readme.html#supported-services"},{"type":"extras","title":"Documentation - ex-oci-sdk","doc":"Detailed documentation is available at [https://hexdocs.pm/ex_oci_sdk](https://hexdocs.pm/ex_oci_sdk).","ref":"readme.html#documentation"},{"type":"extras","title":"License - ex-oci-sdk","doc":"This project is licensed under the Apache License 2.0 License - see the license file for details.","ref":"readme.html#license"},{"type":"extras","title":"Project Status - ex-oci-sdk","doc":"This project is under active development. Contributions are welcome!","ref":"readme.html#project-status"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}